"use strict";
/**
 * Observable
 * reference: https://github.com/zenparsing/zen-observable
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Observable = void 0;
class BaseObservable {
}
class Observable extends BaseObservable {
    constructor(subscriber) {
        super();
        this.subscriber = subscriber;
    }
    subscribe(...args) {
        let subObs;
        let cp;
        if (args[0].complete) {
            cp = args[0].complete;
        }
        else if (args[2]) {
            cp = args[2];
        }
        else {
            cp = () => { };
        }
        const makeComplete = (cp) => {
            return () => {
                if (subObs.closed === false) {
                    subObs.next = () => { };
                    sub.closed = true;
                    subObs.closed = true;
                    cp();
                    switch (typeof (returned)) {
                        case 'undefined': {
                            break;
                        }
                        case 'function': {
                            returned();
                            break;
                        }
                        default: {
                            // todo
                            // returned
                        }
                    }
                }
            };
        };
        if (typeof (args[0]) === 'function') {
            subObs = {
                closed: false,
                next: args[0],
                error: args[1] ? args[1] : (err) => { },
                complete: makeComplete(cp),
            };
        }
        else {
            subObs = {
                closed: false,
                next: args[0].next ? args[0].next : (value) => { },
                error: args[0].error ? args[0].error : (err) => { },
                complete: makeComplete(cp)
            };
        }
        const returned = this.subscriber(subObs);
        const sub = {
            closed: false,
            unsubscribe: makeComplete(() => { }),
        };
        return sub;
    }
}
exports.Observable = Observable;
//# sourceMappingURL=observable.js.map